#include <cstdio>
#include <cstdlib>
#include <ctime>
#include <vector>
#include <utility>

/*
xorshift
http://d.hatena.ne.jp/pashango_p/mobile?guid=on&date=20090717
*/

static unsigned int x=123456789;
static unsigned int y=362436069;
static unsigned int z=521288629;
static unsigned int w=88675123;

void seed(unsigned int a,unsigned int b,unsigned int c,unsigned int d) {
	if((a|b|c|d)==0)return;
	x=a;y=b;z=c;w=d;
}

unsigned int randint(void) {
	unsigned int t;
	t=(x^(x<<11));
	x=y;y=z;z=w;
	w=(w^(w>>19))^(t^(t>>8));
	return w;
}

using namespace std;
typedef long long ll;
typedef pair<ll,ll> llpair;

vector<vector<llpair> > k_heikin(const vector<llpair>& list,int n) {
	vector<int> groups(list.size());
	vector<int> group_num(n);
	vector<llpair> group_heikin(n);
	bool updated=true;
	for(int i=0;i<list.size();i++)groups[i]=randint()%n;
	while(updated) {
		updated=false;
		for(int i=0;i<n;i++) {
			group_num[i]=0;
			group_heikin[i].first=0;
			group_heikin[i].second=0;
		}
		for(int i=0;i<list.size();i++) {
			group_num[groups[i]]++;
			group_heikin[groups[i]].first+=list[i].first;
			group_heikin[groups[i]].second+=list[i].second;
		}
		for(int i=0;i<n;i++) {
			if(group_num[i]>0) {
				group_heikin[i].first/=group_num[i];
				group_heikin[i].second/=group_num[i];
			}
		}
		for(int i=0;i<list.size();i++) {
			int nearest_group=0;
			ll nearest_kyori=0x7fffffffffffffffll;
			for(int j=0;j<n;j++) {
				ll now_kyori=
					(group_heikin[j].first-list[i].first)*
					(group_heikin[j].first-list[i].first)+
					(group_heikin[j].second-list[i].second)*
					(group_heikin[j].second-list[i].second);
				if(now_kyori<nearest_kyori) {
					nearest_kyori=now_kyori;
					nearest_group=j;
				}
			}
			if(nearest_group!=groups[i]) {
				groups[i]=nearest_group;
				updated=true;
			}
		}
	}
	vector<vector<llpair> > result(n);
	for(int i=0;i<list.size();i++) {
		result[groups[i]].push_back(list[i]);
	}
	return result;
}

vector<ll> set_tower(const vector<llpair>& list) {
	ll left,right,up,down;
	left=up=0x7fffffffffffffffll;
	right=down=-0x7fffffffffffffffll;
	for(int i=0;i<list.size();i++) {
		if(list[i].first<left)left=list[i].first;
		if(list[i].first>right)right=list[i].first;
		if(list[i].second<up)up=list[i].second;
		if(list[i].second>down)down=list[i].second;
	}
	ll cx,cy,r;
	cx=(left+right)/2;
	cy=(up+down)/2;
	r=0;
	for(int i=0;i<list.size();i++) {
		ll request_r=
			(list[i].first-cx)*(list[i].first-cx)+
			(list[i].second-cy)*(list[i].second-cy);
		if(request_r>r)r=request_r;
	}
	vector<ll> result(3);
	result[0]=cx;
	result[1]=cy;
	result[2]=r;
	return result;
}

int main(int argc,char* argv[]) {
	int repeat_num=1;
	if(argc>1)sscanf(argv[1],"%d",&repeat_num);

	srand((unsigned int)time(NULL));
	seed(rand(),rand(),rand(),rand());

	int house_num,denpa_num;
	scanf("%d%d",&house_num,&denpa_num);
	vector<llpair> list(house_num);
	for(int i=0;i<house_num;i++) {
		scanf("%I64d%I64d",&list[i].first,&list[i].second);
	}
	vector<vector<ll> > result;
	ll best_score=0x7fffffffffffffffll;
	for(int repeat=0;repeat<repeat_num;repeat++) {
		vector<vector<llpair> > groups=k_heikin(list,denpa_num);
		vector<vector<ll> > now_result;
		ll now_score=0;
		for(int i=0;i<denpa_num;i++) {
			now_result.push_back(set_tower(groups[i]));
			now_score+=now_result[i][2];
		}
		if(now_score<best_score) {
			result=now_result;
			best_score=now_score;
		}
	}
	for(int i=0;i<denpa_num;i++) {
		printf("%I64d %I64d %I64d\n",result[i][0],result[i][1],result[i][2]);
	}
	return 0;
}
