#include <stdio.h>
#include <stdlib.h>

//broadcasting checker

typedef long long ll;

typedef struct {
	ll x,y;
	int covered;
} house_t;

typedef struct {
	ll x,y,energy;
} denpatou_t;

int house_max;
house_t house[500];
int denpatou_max;
denpatou_t denpatou[30];

int main(int argc,char* argv[]) {
	FILE* input;
	FILE* output;
	int i;
	ll energy_sum=0;
	int not_covered=0;
	ll now_energy_sum;
	if(argc<3) {
		printf("Usage: ./broadcasting_check2 <input> <output> [best output]\n");
		return -1;
	}
	input=fopen(argv[1],"r");
	output=fopen(argv[2],"r");
	if(!input || !output) {
		if(input)fclose(input);
		if(output)fclose(output);
		printf("File open error\n");
		return -1;
	}
	fscanf(input,"%d%d",&house_max,&denpatou_max);
	for(i=0;i<house_max;i++) {
		fscanf(input,"%I64d%I64d",&house[i].x,&house[i].y);
	}
	for(i=0;i<denpatou_max;i++) {
		fscanf(output,"%I64d%I64d%I64d",
			&denpatou[i].x,&denpatou[i].y,&denpatou[i].energy);
	}
	fclose(input);
	fclose(output);
	for(i=0;i<denpatou_max;i++) {
		int j;
		for(j=0;j<house_max;j++) {
			if((denpatou[i].x-house[j].x)*(denpatou[i].x-house[j].x)+
					(denpatou[i].y-house[j].y)*(denpatou[i].y-house[j].y)
					<=denpatou[i].energy) {
				house[j].covered++;
			}
		}
		energy_sum+=denpatou[i].energy;
	}
	for(i=0;i<house_max;i++) {
		if(!house[i].covered) {
			/*printf("uncovered house: No. %d (%I64d,%I64d)\n",
				i,house[i].x,house[i].y);*/
			not_covered=1;
		}
	}
	if(!not_covered)printf("Accepted "); else printf("Error ");
	printf("Energy total: %I64d\n",energy_sum);
	if(argc>=4 && !not_covered) {
		now_energy_sum=energy_sum;
		output=fopen(argv[3],"r");
		if(!output) {
			printf("Best: File Open Error\n");
			return -1;
		}
		for(i=0;i<denpatou_max;i++) {
			fscanf(output,"%I64d%I64d%I64d",
				&denpatou[i].x,&denpatou[i].y,&denpatou[i].energy);
		}
		fclose(output);
		energy_sum=0;
		not_covered=0;
		for(i=0;i<denpatou_max;i++) {
			int j;
			for(j=0;j<house_max;j++) {
				if((denpatou[i].x-house[j].x)*(denpatou[i].x-house[j].x)+
						(denpatou[i].y-house[j].y)*(denpatou[i].y-house[j].y)
						<=denpatou[i].energy) {
					house[j].covered++;
				}
			}
			energy_sum+=denpatou[i].energy;
		}
		for(i=0;i<house_max;i++) {
			if(!house[i].covered) {
				not_covered=1;
			}
		}
		printf("Best: ");
		if(!not_covered) {
			printf("Energy total: %I64d\n",energy_sum);
			if(now_energy_sum<energy_sum) {
				char command[1024];
				sprintf(command,"copy /Y %s %s > NUL 2>&1",argv[2],argv[3]);
				system(command);
				printf("Best data updated!\n");
			}
		} else {
			printf("Error\n");
		}
	}
	return 0;
}
